/* ---------------------------------------------------------- 
%   (C)1994,1995 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */

#ifndef _KLIC_GG_METHTAB_H_
#define _KLIC_GG_METHTAB_H_

extern q GG_STD_SUSPEND();

/* runtime/generic.c */
extern void GD_STD_DEALLOCATE(struct data_object* GD_SELF);
extern q GD_STD_ENCODE(struct data_object* self, void* buffer);

#define GG_STD_DEALLOCATE GD_STD_DEALLOCATE
#define GG_STD_ENCODE GD_STD_ENCODE

struct generator_object_method_table GG_method_table
  = {
#ifndef GGUSE_MY_UNIFY
#error "please GGDEF_UNIFY and GGUSE_MY_UNIFY"
#else
  GG_rappend(active_unify) ,
#endif

#ifndef GGUSE_MY_GENERATE
#error "please GGDEF_GENERATE and GGUSE_MY_GENERATE"
  GG_STD_GENERATE ,
#else
  GG_rappend(generate) ,
#endif

#ifndef GGUSE_MY_SUSPEND
  GG_STD_SUSPEND,
#else
  GG_rappend(suspend) ,
#endif

#ifndef GGUSE_MY_PRINT
#error "please GGDEF_PRINT and GGUSE_MY_PRINT"
#else
 GG_rappend(print) ,
#endif

#ifndef GGUSE_MY_GC
#error "please GGDEF_GC and GGUSE_MY_GC"
#else
 GG_rappend(gc) ,
#endif

#ifndef GGUSE_MY_DEALLOCATE
 GG_STD_DEALLOCATE ,
#else
 GG_rappend(deallocate) ,
#endif

#ifndef GGUSE_MY_ENCODE
 GG_STD_ENCODE 
#else
 GG_rappend(encode)
#endif

};

#endif /* _KLIC_GG_METHTAB_H_ */
